<?php
/**
 * Copyright (c) 2012, Gemorroj
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright notice,
 *       this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 * @author Gemorroj
 * @version 2.0
 */
/**
 * Спамер
 *
 * @author Gemorroj
 * @version 2.0
 * @license http://www.opensource.org/licenses/bsd-license.php New BSD License
 */
class Spammer
{
    /**
     * Отладочный режим
     * 
     * @var bool
     */
    public $verbose   = false;
    /**
     * Ключ для antigate.com
     * 
     * @var string
     */
    public $antigateKey;
    /**
     * Массив заголовков
     * 
     * @var array
     */
    public $headers   = array();
    /**
     * Массив Cookies
     * 
     * @var array
     */
    private $cookies = array();
    /**
     * Таймаут соединения с сервером
     * 
     * @var int
     */
    public $timeout = 10;
    /**
     * Таймаут между запросами страниц онлайна
     * 
     * @var int
     */
    public $onlineTimeout = 0;
    /**
     * Прокси
     * 
     * @var string
     */
    public $proxy;
    /**
     * Файл с данными
     * 
     * @var string
     */
    public $file = 'database.db';
    /**
     * Ответ удаленного сервера
     * 
     * @var string
     */
    public $response;
    /**
     * Доменное имя сайта, который спамим
     * 
     * @var string
     */
    public $host;
    /**
     * Значение для CURLOPT_ENCODING
     *
     * @var string
     */
    public $encoding = '';
    /**
     * Файл с логом запросов
     *
     * @var string
     */
    public $logFile = 'request.log';
    /**
     * @var PDO
     */
    private $_pdo;


    /**
     * Конструктор
     * 
     * @param  string $host  доменное имя сайта, который спамим
     * @param  string $proxy прокси
     */
    public function __construct ($host, $proxy = null)
    {
        $this->host     = $host;
        $this->proxy    = $proxy;

        $this->_pdo = new PDO('sqlite:' . $this->file);

        $this->headers['Referer']           = 'http://' . $this->host;
        $this->headers['User-Agent']        = $this->getBrowsers(mt_rand());
        $this->headers['Accept']            = 'text/html, application/xml;q=0.9, application/xhtml+xml, image/png, image/jpeg, image/gif, image/x-xbitmap, */*;q=0.1';
        $this->headers['Accept-Charset']    = 'iso-8859-1, utf-8, utf-16, *;q=0.1';
        $this->headers['Accept-Language']   = 'ru-RU,ru;q=0.9,en;q=0.8';
        $this->headers['Connection']        = 'close';
    }


    /**
     * @return PDO
     */
    public function getPdo()
    {
        return $this->_pdo;
    }


    /**
     * Добавление HTTP заголовков
     * 
     * @param   string $key     имя заголовка
     * @param   string $value   значение заголовка
     * @return  array           возвращает массив заголовков
     */
    public function setHeader ($key, $value)
    {
        $this->headers[rawurlencode($key)] = rawurlencode($value);
        return $this->headers;
    }


    /**
     * Авторизация
     * 
     * @param   string $url         URL на который отправляется запрос
     * @param   array $authorise    данные передаваемые через POST для авторизации (логин, пароль)
     * @param   string $regexp      регулярное выражение для выдирания идентификатора сессии
     * @param   bool $header        нужно ли получать заголовки ответа
     * @param   bool $nobody        нужно ли получать тело страницы
     * @param   bool $location      переходить ли по переадресациям
     * @return  string              результат регулярного выражения или ответ сервера
     */
    public function getAuth ($url, array $authorise, $regexp = '', $header = true, $nobody = false, $location = true)
    {
        $get = $this->get($url, $authorise, $header, $nobody, $location);

        if ($regexp) {
            preg_match($regexp, $get, $array);
            return $array[1];
        } else {
            return $get;
        }
    }


    /**
     * Сбор онлайн
     * 
     * @param   string $url1        URL на который отправляется первый запрос (не работает, если заранее указано количество страниц)
     * @param   string $regexp      регулярное выражение для выдирания общего количества страниц (не работает, если заранее указано количество страниц)
     * @param   string $url2        URL на который отправляются запросы 
     * @param   string $regexp_user регулярное выражение для выдирания имен пользователей
     * @param   string $regexp_id   регулярное выражение для выдирания ID пользователей
     * @param   int $pg             количество страниц (не обязательный)
     * @param   int $step           шаг между страницами
     * @param   int $start          начало отсчета страниц
     * @param   int $limit          лимит на кол-во пользователей (0 - без ограничений)
     * @param   string $regexp_stop регулярное выражение для остановки сбора онлайн. (нужно если нет возможности получить кол-во страниц)
     */
    public function getOnline ($url1 = '', $regexp = '', $url2, $regexp_user, $regexp_id, $pg = 0, $step = 1, $start = 0, $limit = 0, $regexp_stop = '')
    {
        if (!$pg) {
            preg_match($regexp, $this->get($url1, array(), false, false), $pg);
            $pg = $pg[1];
        }

        $iterator = 0;
        for ($i = $start; $i <= $pg; ++$i) {
            if ($this->onlineTimeout && $i > $start) {
                sleep($this->onlineTimeout);
            }
            $get = $this->get($url2 . ($i * $step), array(), false, false);
            if ($regexp_stop && preg_match($regexp_stop, $get)) {
                break;
            }

            preg_match_all($regexp_user, $get, $array_user);
            preg_match_all($regexp_id, $get, $array_id);

            //$a = sizeof($array_user[1]);
            $a = sizeof($array_id[1]);

            $users = array();
            for ($ii = 0; $ii < $a; ++$ii) {
                $users[] = array(
                    'userid' => $array_id[1][$ii],
                    'username' => htmlspecialchars_decode($array_user[1][$ii], ENT_QUOTES),
                );
                $iterator++;
            }
            $this->setUsers($users);

            if ($limit && $iterator >= $limit) {
                break;
            }
        }
    }


    /**
     * Сохраняет пользователей
     * 
     * @param   array $users    массив пользователей, которых нужно сохранить
     * @param   bool  $spammed  проспмален пользователь или нет
     */
    public function setUsers (array $users, $spammed = false)
    {
        $q = $this->_pdo->prepare('INSERT OR IGNORE INTO users (userid, username, spammed) VALUES (?, ?, ?)');
        foreach ($users as $user) {
            $q->execute(array($user['userid'], $user['username'], $spammed ? 1 : 0));
        }
    }


    /**
     * Пользователи в БД
     *
     * @return  array
     */
    public function getUsers ()
    {
        return $this->_pdo->query('SELECT * FROM users')->fetchAll(PDO::FETCH_ASSOC);
    }


    /**
     * Проспамленные пользователи в БД
     *
     * @return  array
     */
    public function getSpammedUsers ()
    {
        return $this->_pdo->query('SELECT * FROM users WHERE spammed = 1')->fetchAll(PDO::FETCH_ASSOC);
    }


    /**
     * Непроспамленные пользователи в БД
     *
     * @return  array
     */
    public function getNotSpammedUsers ()
    {
        return $this->_pdo->query('SELECT * FROM users WHERE spammed = 0')->fetchAll(PDO::FETCH_ASSOC);
    }


    /**
     * Количество проспамленных пользователей в БД
     *
     * @return  string
     */
    public function getCountSpammedUsers ()
    {
        return $this->_pdo->query('SELECT COUNT(1) FROM users WHERE spammed = 1')->fetchColumn();
    }


    /**
     * Количество непроспамленных пользователей в БД
     *
     * @return  string
     */
    public function getCountNotSpammedUsers ()
    {
        return $this->_pdo->query('SELECT COUNT(1) FROM users WHERE spammed = 0')->fetchColumn();
    }


    /**
     * Количество пользователей в БД
     * 
     * @return  string json
     */
    public function getCountUsers ()
    {
        header('Content-Type: application/json; charset=UTF-8');
        header('Cache-control: no-cache');
        echo '[' . $this->getCountSpammedUsers() . ',' . $this->getCountNotSpammedUsers() . ']';
    }


    /**
     * Формируем массив HTTP заголовков
     *
     * @return array
     */
    protected function _getHeaders()
    {
        $h = array();
        foreach ($this->headers as $k => $v) {
            $h[] = $k . ': ' . $v;
        }
        if ($this->cookies) {
            $cookie = 'Cookie: ';
            foreach ($this->cookies as $k => $v) {
                $cookie .= $k . '=' . $v . '; ';
            }
            $h[] = trim($cookie);
        }

        return $h;
    }


    /**
     * Получаем строку POST
     *
     * @param array $post
     *
     * @return string
     */
    protected function _getPost(array $post)
    {
        $out = '';
        foreach ($post as $k => $v) {
            $out .= rawurlencode($k) . '=' . rawurlencode($v) . '&';
        }

        return rtrim($out, '&');
    }


    /**
     * HTTP запрос
     * 
     * @param   string $url   URL на который отправляется запрос
     * @param   array $post   POST запрос
     * @param   bool $header  выдавать ли в ответе заголовки
     * @param   bool $nobody  выдавать ли в ответе тело страницы
     * @param   bool $location переходить ли по переадресациям
     * @return  string        страница полученная с удаленного серверав результате запроса
     */
    public function get ($url, array $post = array(), $header = true, $nobody = false, $location = true)
    {
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_HTTPHEADER, $this->_getHeaders());
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, $location);
        curl_setopt($curl, CURLOPT_AUTOREFERER, false);
        curl_setopt($curl, CURLOPT_TIMEOUT, $this->timeout);
        curl_setopt($curl, CURLOPT_HEADER, $header);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($curl, CURLOPT_NOBODY, $nobody);
        curl_setopt($curl, CURLOPT_VERBOSE, false);
        curl_setopt($curl, CURLOPT_ENCODING, $this->encoding);
        if ($this->verbose) {
            curl_setopt($curl, CURLINFO_HEADER_OUT, true);
        }

        if ($post) {
            curl_setopt($curl, CURLOPT_POST, true);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $this->_getPost($post));
        }

        if ($this->proxy) {
            curl_setopt($curl, CURLOPT_PROXY, $this->proxy);
            curl_setopt($curl, CURLOPT_PROXYTYPE, CURLPROXY_HTTP);
        }

        $get = (string)curl_exec($curl);
        if ($this->verbose) {
            $h = curl_getinfo($curl, CURLINFO_HEADER_OUT);
            file_put_contents($this->logFile, "URL: " . $url . "\nHEADERS:\n" . $h . "POST:" . print_r($post, true) . "\nRESPONSE:\n" . $get . "\n\n\n\n\n---\n", FILE_APPEND);
        }
        curl_close($curl);

        return $this->response = $get;
    }


    /**
     * Спам
     * 
     * @param   int   $userid     Юзер, которого спамим
     * @param   string $url       URL на который отправляется запрос
     * @param   array $post       POST запрос
     * @param   string $regexp    регулярное выражение для поиска совпадения текста в случае удачного запроса
     * @param   bool $header      нужно ли получать заголовки ответа
     * @param   bool $nobody      нужно ли получать тело страницы
     * @param   bool $location    переходить ли по переадресациям
     * @return  mixed             true в случае успешного выполнения регулярного выражения, полученная страница в противном случае
     */
    public function spam ($userid, $url, array $post = array(), $regexp = '', $header = false, $nobody = false, $location = true)
    {
        $get = $this->get($url, $post, $header, $nobody, $location);
        if ($regexp && preg_match($regexp, $get)) {
            $this->_pdo->prepare('UPDATE users SET spammed = 1 WHERE userid = ?')->execute(array($userid));
            $get = true;
        }
        return $get;
    }


    /**
     * Очистка БД
     *
     * @return  int успешно ли обновлена БД
     */
    public function clean ()
    {
        $this->_pdo->exec('DELETE FROM users');
        $this->_pdo->exec('VACUUM');
    }
    
    
    /**
     * Отметка всех пользователей как проспамленных
     *
     * @return  int записаны ли данные в БД
     */
    public function setAllSpammed ()
    {
        $this->_pdo->exec('UPDATE users SET spammed = 1');
    }


    /**
     * Отметка всех пользователей как не проспамленных
     *
     * @return  int записаны ли данные в БД
     */
    public function setAllNotSpammed ()
    {
        $this->_pdo->exec('UPDATE users SET spammed = 0');
    }


    /**
     * Получаем Cookies последнего ответа
     *
     * @return  array  Cookies
     */
    public function getCookies ()
    {
        preg_match_all('/\nSet\-Cookie:\s*?(.+);.*/iU', $this->response, $cookies);
        foreach ($cookies[1] as $v) {
            $x = explode('=', $v);
            $this->cookies[$x[0]] = $x[1];
        }
        return $this->cookies;
    }


    /**
     * Получает код капчи через antiagate.com
     * 
     * @param   string $file      URL картинки
     * @param   string $ext       тип картинки (jpg, gif, png)
     * @param   int $rtimeout     задержка между опросами статуса капчи
     * @param   int $mtimeout     время ожидания ввода капчи
     * @param   int $is_phrase    0 либо 1 - флаг "в капче 2 и более слов"
     * @param   int $is_regsense  0 либо 1 - флаг "регистр букв в капче имеет значение"
     * @param   int $is_numeric   0 либо 1 - флаг "капча состоит только из цифр"
     * @param   int $min_len      0 (без ограничений), любая другая цифра указывает минимальную длину текста капчи
     * @param   int $max_len      0 (без ограничений), любая другая цифра указывает максимальную длину текста капчи
     * @return  mixed             false или код с картинки
     */
    public function getAntigate ($file, $ext = 'jpg', $rtimeout = 5, $mtimeout = 120, $is_phrase = 0, $is_regsense = 0, $is_numeric = 0, $min_len = 0, $max_len = 0)
    {
        $post = array(
            'method'    => 'base64',
            'key'       => $this->antigateKey,
            'body'      => base64_encode($this->get($file, array(), false, false)),
            'ext'       => $ext,
            'phrase'	=> $is_phrase,
            'regsense'	=> $is_regsense,
            'numeric'	=> $is_numeric,
            'min_len'	=> $min_len,
            'max_len'	=> $max_len,
        );

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, 'http://antigate.com/in.php');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_TIMEOUT, 60);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
        $result = curl_exec($ch);
        curl_close($ch);

        if (strpos($result, 'ERROR') !== false) {
            return false;
        } else {
            $ex = explode('|', $result);
            $captcha_id = $ex[1];
            $waittime = 0;
            sleep($rtimeout);
            while (true) {
                $result = file_get_contents('http://antigate.com/res.php?key=' . $this->antigateKey . '&action=get&id=' . $captcha_id);
                if (strpos($result, 'ERROR') !== false) {
                    return false;
                }
                if ($result == 'CAPCHA_NOT_READY') {
                	$waittime += $rtimeout;
                	if ($waittime > $mtimeout) {
                		break;
                	}
                	sleep($rtimeout);
                } else {
                	$ex = explode('|', $result);
                	if (trim($ex[0]) == 'OK') {
                	   return trim($ex[1]);
                    }
                }
            }

            return false;
        }
    }


    /**
     * Возвращает браузер по указанному ID, либо случайный
     * 
     * @param int $id ID браузера в массиве, -1 - случайный браузер
     * @return string  браузер
     */
    public function getBrowsers ($id = -1)
    {
        $browsers = array (
            'HTCP3300-Mozilla/4.0 (compatible; MSIE 4.01; Windows CE; PPC; 240x320)',
            'Panasonic-GAD87/A22 UP.Link/1.1',
            'Panasonic-VS6/1.0/RP1 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'LGE-VX8300/1.0 UP.Browser/6.2.3.2 (GUI) MMP/2.0',
            'LG-C1100 MIC/WAP2.0 MIDP-2.0/CLDC-1.0',
            'Mozilla/5.0 (SymbianOS/9.1; U; en-us) AppleWebKit/413 (KHTML, like Gecko) Safari/413',
            'Mozilla/4.0 (compatible; MSIE 5.5; Symbian OS-Series60) NetFront/3.3',
            'Mozilla/4.0 (compatible; MSIE 4.01; Windows CE; Smartphone; 240x320)',
            'Mozilla/4.0 (MobilePhone; BREW/2.0) NetFront/3.1',
            'Mozilla/5.0 (Windows; U; Windows NT 5.1; ru; rv:1.8.1.3) Gecko/20070309 Firefox/2.0.0.3',
            'SEC-SGHD800/1.0 NetFront/3.2 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SEC-SGHX660/1.0 TSS/2.5',
            'SEC-SGHE900/1.0 NetFront/3.2 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SAMSUNG-SGH-E370/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 UP.Browser/6.2.3.3.c.1.101 (GUI) MMP/2.0',
            'SAMSUNG-SGH-Z540/1.0 SHP/VPP/R5 SMM-MMS/1.2.0 profile/MIDP-2.0 configuration/CLDC-1.1',
            'SAMSUNG-SGH-D900/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 UP.Browser/6.2.3.3.c.1.101 (GUI) MMP/2.0',
            'SAMSUNG SGH-X100 UP.Browser/6.1.0.6 (GUI) MMP/1.0 UP.Link/5.1.1',
            'SAMSUNG-SGH-E350E/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 UP.Browser/6.2.3.3.c.1.101 (GUI) MMP/2.0',
            'SAMSUNG-SGH-D500E/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 UP.Browser/6.2.3.3.c.1.101 (GUI) MMP/2.0',
            'SAMSUNG-SGH-E730/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 UP.Browser/6.2.3.3.c.1.101 (GUI) MMP/2.0',
            'SAMSUNG-SGH-X480/1.0',
            'SAMSUNG-SGH-D600/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 UP.Browser/6.2.3.3.c.1.101 (GUI) MMP/2.0',
            'SAMSUNG-SGH-D820/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 UP.Browser/6.2.3.3.c.1.101 (GUI) MMP/2.0',
            'SIE-CX65/41 UP.Browser/7.0.2.2.d.1.100(GUI) MMP/2.0 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SIE-M55/10 UP.Browser/6.1.0.5.c.6 (GUI) MMP/1.0',
            'SIE-S65/58 UP.Browser/7.0.2.2.d.4(GUI) MMP/2.0 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SIE-C75/22 UP.Browser/7.0.2.2.d.7(GUI) MMP/2.0 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SIE-C75/24 UP.Browser/7.0.2.2.d.7(GUI) MMP/2.0 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SIE-M55/11 Profile/MIDP-1.0 Configuration/CLDC-1.0 UP.Browser/6.1.0.7.3 (GUI) MMP/1.0',
            'SIE-AX72/02 Profile/MIDP-1.0 Configuration/CLDC-1.0 UP.Browser/6.1.0.7.3.102 (GUI) MMP/1.0',
            'SIE-M55/11 Profile/MIDP-1.0 Configuration/CLDC-1.0 UP.Browser/6.1.0.7.3 (GUI) MMP/1.0',
            'SIE-C65/41 UP.Browser/7.0.2.2.d.1.100(GUI) MMP/2.0 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SIE-C65/12 UP.Browser/7.0.0.1.c.3 (GUI) MMP/2.0 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SIE-A60/14 UP.Browser/6.1.0.5.c.6 (GUI) MMP/1.0',
            'SIE-CX70/43 UP.Browser/7.0.2.2.d.1.100(GUI) MMP/2.0 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SIE-E71/42 UP.Browser/7.1.0.k.6(GUI) MMP/2.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 Browser/UP.Browser/7.1',
            'SIE-CF62/21 Profile/MIDP-1.0 Configuration/CLDC-1.0 UP.Browser/6.1.0.7.3 (GUI) MMP/1.0',
            'SonyEricssonK500i/R2AE SEMC-Browser/4.0.3 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK750i/R1CA/SN353406018988479 Browser/SEMC-Browser/4.2 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonW300i/R9A Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK750i/R1AA Browser/SEMC-Browser/4.2 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK320i/R4EA Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK800i/R1JG Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonZ710i/R1JC Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonW810i/R4EA Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK800i/R1CF Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK310i/R4EA Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonW800i/R1AA Browser/SEMC-Browser/4.2 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK750i/R1CA Browser/SEMC-Browser/4.2 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK790i/R1JG Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonW550i/R4CB Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK610i/R1ED Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK700i/R2A SEMC-Browser/4.0 Profile/MIDP-1.0 MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK700i/R2AA SEMC-Browser/4.0.2 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK700i/R2AE SEMC-Browser/4.0.3 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK700i/R2AY SEMC-Browser/4.0.3 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK700i/R2CA SEMC-Browser/4.0.3 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK750i/R1A Browser/SEMC-Browser/4.2 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK750i/R1AA/SN357850005934499 Browser/SEMC-Browser/4.2 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK750i/R1BC Browser/SEMC-Browser/4.2 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK750i/R1DB Browser/SEMC-Browser/4.2 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK750i/R1J Browser/SEMC-Browser/4.2 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK750i/R1J/SN356551006126264 Browser/SEMC-Browser/4.2 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK750i/R1J/SN356551006632212 Browser/SEMC-Browser/4.2 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK750i/R1L Browser/SEMC-Browser/4.2 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK750i/R1N Browser/SEMC-Browser/4.2 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK790i/R1GB Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK790i/R1JC Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonK800i/R1CD Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonP900/R101 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'SonyEricssonP900/R102 Profile/MIDP-2.0 Configuration/CLDC-1.0 Rev/MR4',
            'SonyEricssonP910c/R2A SEMC-Browser/Symbian/3.0 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'SonyEricssonP910i/R1A SEMC-Browser/Symbian/3.0 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'SonyEricssonP910i/R2B SEMC-Browser/Symbian/3.0 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'SonyEricssonP990i/R100 Mozilla/4.0 (compatible; MSIE 6.0; Symbian OS; 598) Opera 8.65 [en]',
            'SonyEricssonS700i/R3B SEMC-Browser/4.0.1 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'SonyEricssonT290i/R101',
            'SonyEricssonT300/R101',
            'SonyEricssonT300/R201',
            'SonyEricssonT610/R301 Profile/MIDP-1.0 Configuration/CLDC-1.0',
            'SonyEricssonT610/R601 Profile/MIDP-1.0 Configuration/CLDC-1.0',
            'SonyEricssonT616/R201 Profile/MIDP-1.0 Configuration/CLDC-1.0',
            'SonyEricssonT618/R201 Profile/MIDP-1.0 Configuration/CLDC-1.0',
            'SonyEricssonT618/R401 Profile/MIDP-1.0 Configuration/CLDC-1.0',
            'SonyEricssonT628/R401 Profile/MIDP-1.0 Configuration/CLDC-1.0',
            'SonyEricssonT630/R401 Profile/MIDP-1.0 Configuration/CLDC-1.0',
            'SonyEricssonT630/R401 Profile/MIDP-1.0 Configuration/CLDC-1.0 UP.Link/6.3.0.0.0',
            'SonyEricssonT630/R601 Profile/MIDP-1.0 Configuration/CLDC-1.0',
            'SonyEricssonT630/R601 Profile/MIDP-1.0 Configuration/CLDC-1.0 UP.Link/5.1.1',
            'MOT-T720M/AS_G_05.06.20R MIB/2.0 Profile/MIDP-1.0 Configuration/CLDC-1.0',
            'MOT-TA02/06.04.1CR MIB/1.2.1',
            'MOT-TA02/06.04.1FR MIB/1.2.1',
            'MOT-TA02/06.04.34R MIB/1.2.1',
            'MOT-ta02/E-G_C_5.2.1_R MIB/1.2.1 Profile/MIDP-1.0 Configuration/CLDC-1.0',
            'MOT-V171 UP.Browser/6.2.2.7 (GUI) MMP/1.0',
            'MOT-V180/0B.D1.09R MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'MOT-V185/0B.D2.22R MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'MOT-V220/0B.D2.23R MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'MOT-V3/0E.40.3CR MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'MOT-V3/0E.40.3CR MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0 UP.Link/1.1',
            'MOT-V3/0E.40.3ER MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'MOT-V3/0E.42.0ER MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'MOT-V3/0E.42.10R MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'MOT-V300/0B.09.1DR MIB/2.2 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'MOT-V300/0B.09.1FR MIB/2.2 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'MOT-V300/0B.09.38R MIB/2.2 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'MOT-V3i/08.D8.88R MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'MOT-V3i/08.B4.85R MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'MOT-V635/08.48.6FR MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'MOT-V180/0B.D2.23R MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'MOT-E398/0E.20.95R MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'MOT-E398/0E.30.49R MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'MOT-L7/08.B7.AER MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'Opera/8.01 (J2ME/MIDP; Opera Mini/3.0.6306/1662; ru; U; ssr)',
            'Opera/8.01 (J2ME/MIDP; Opera Mini/2.0.4509/1630; ru; U; ssr)',
            'Opera/8.01 (J2ME/MIDP; Opera Mini/2.0.3920/1662; ru; U; ssr)',
            'Opera/8.01 (J2ME/MIDP; Opera Mini/3.1.7196/1662; ru; U; ssr)',
            'Opera/9.20 (Windows NT 5.1; U; ru)',
            'Opera/9.10 (Windows NT 6.0; U; ru)',
            'Nokia5500d/2.0 (03.14) SymbianOS/9.1 Series60/3.0 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'Nokia6101/2.0 (03.35) Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'Nokia7610/2.0 (5.0509.0) SymbianOS/7.0s Series60/2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'Nokia6020/2.0 (04.10) Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'NokiaN72/2.0617.1.0.3 Series60/2.8 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'NokiaE50-1/3.0 (06.27.1.0) SymbianOS/9.1 Series60/3.0 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'Nokia6230/2.0 (05.35) Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'Nokia2610/2.0 (04.50) Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'NokiaN70-1/5.0609.2.0.1 Series60/2.8 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'NokiaN73-1/3.0705.1.0.31 Series60/3.0 Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'Nokia3230/2.0 (4.0537.0) SymbianOS/7.0s Series60/2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'Nokia6060/2.0 (k3.62) Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'Nokia6230i/2.0 (03.40) Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'Nokia6260/2.0 (3.0448.0) SymbianOS/7.0s Series60/2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'Nokia7610/2.0 (6.0522.0) SymbianOS/7.0s Series60/2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0',
            'Nokia6060/2.0 (k3.62) Profile/MIDP-2.0 Configuration/CLDC-1.1',
            'NokiaN73-1/2.0628.0.0.1 S60/3.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 UP.Link/6.3.1.13.0',
        );

        if (isset($browsers[$id])) {
            return $browsers[$id];
        } else {
            return $browsers[array_rand($browsers, 1)];
        }
    }
}
