<?php
/* 
readme.txt - если уже читали, то пропустите это

WebTransclucator v1.01

СКРИПТ ДЛЯ РЕАЛЬНОГО ЗАРАБОТКА В СЕТИ НА БАННЕРНЫХ ПОКАЗАХ
----------------------------------------------------------

Скрипт предназначен для обмана поисковых серверов - Yandex, Google, 
Rambler и подобных. При этом они начинают направлять на ваш сайт огромное 
количество посетителей, а вы зарабатываете на баннерных показах и 
подсчитываете немалые доходы.

Как это работает
----------------

1. При каждом обращении к скрипту генерируется страница, содержащая 
бессмысленный текст и имеющая ссылки на несколько других страниц.

2. Когда поисковый сервер добирается до страницы, он выкачивает ее и все,
что с ней связано, переходя по множеству ссылок.

3. Текст изменяется динамически и индексируется поисковым сервером. Текст 
построен таким образом, чтобы вызвать максимальное количество обращений 
по запросам пользователей. Заголовки в тексте соответствуют библиотечному 
классификатору (УДК) и охватывают т.о. все возможные отрасли знаний.

4. Когда на поисковом сервере пользователь набирает ключевое слово или фразу,
в числе первых ссылок будет ссылка на ваш ресурс (где установлен скрипт). 
Пользователь переходит по ней и отсматривает любое количество указанных
вами баннеров.
Можно так настроить скрипт, что пользователь, пришедший с поисковика, сразу 
направляется на какой-то URL (например, на ваш сайт, который вы хотите 
сделать посещаемым).

5. За баннерные показы вам начисляются деньги. За десятки тысяч баннерных 
показов вы получаете приличную зарплату.

Вы можете зарегистрироваться в любой баннерной сети, либор рекламировать
какой-то определенный ресурс, показывая только его баннер или переводя всех 
посетителей на него.

Как это настроить
-----------------

Для заработка на баннерных показах
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
1. Найдите хостинг, где среди прочего указан с PHP4. Все можно сделать
бесплатно на 

http://www.km.ru/
http://www.wallst.ru/
http://www.hut.ru/
http://www.by.ru/

Или платно у любого коммерческого хостера, например 

http://www.ruweb.net/

2. Найдите подходящую баннерную сеть, или спонсора, который платит за 
баннерные показы, или партнерскую программу, основанную на показах 
банеров. Например, http://www.rle.ru/

3. Напишите свой баннерный код и произведите другие необходимые 
настройки в файле index.php. 

4. Установите скрипт, скопировав все файлы по FTP. 
Для работы скрипта важны файлы:
index.php
links.txt

5. Зарегистрируйте сайт на известных поисковых серверах и в каталогах.

http://www.yandex.ru/
http://www.rambler.ru/
http://www.google.ru/

6. Пользуйтесь и зарабатывайте деньги.


Для увеличения посещаемости вашего сайта
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Если вы хотите увеличить посещаемость своего сайта, настройте и установите 
скрипт. Оставьте на какой-либо странице незаметную ссылку на него. Например,
указав:
<a href="index.php">.</a> или
<a href="index.php">Сюда не ходите!</a>
Не делайте ссылку цветом фона, хитрые поисковые сервера обнаружат это и 
не станут индексировать ее.

Подробнейшие инструкции и советы но настройке содержатся в самом файле 
скрипта - index.php.


История
-------

Скрипт реализует оригинальную идею автора, не имеющую аналогов в Интернете.
Скрипт прошел успешные испытания, он был просто выложен в сети без всякой 
регистрации на поисковиках. Через месяц появились первые посетители и 
баннерные показы. Через 3 месяца число посетителей стало довольно большим и 
эксперимент пришлось прекратить.

Желаю вам удачи и хороших доходов в онлайн-бизнесе!

XCoder scripts@nekto.com

*/

//=============================================================================
//============================ НАЧАЛО КОДА ====================================
//=============================================================================
// Настройки начинаются здесь. Если вы плохо знаете PHP, то все равно сможете 
// настроить. Только делайте резервные копии, прежде чем вносить изменения.
  
// 1. Примерное количество ссылок, которые будет выкачивать поисковый сервер 
// Рекомендуется ставить значения не меньше 1000 - ресурс воспримут как 
// крупный и информативный.
// Это примерное число "уникальных" страниц, которые генерирует скрипт.
// Чем больше - тем больше исходящий трафик, если вы за него платите. Но
// и тем солиднее выглядит ресурс для поисковика.
// Предела почти нет, но реально больше 2000 нет особого смысла ставить.
// Умножьте размер получившейся у скрипта страницы на это число - столько 
// поисковик скачает у вас за один приход.
// Можно оставить как написано.

$PagesCountApprox = 2000; // Поздравляю ! 
                          // теперь на вашем сайте 2000 html-страниц, 
                          // прямо как у www.microsoft.com ;)

// 2. Теперь настройки переадресации для посетителей, пришедших с поисковиков.
// Это актуально, если вы занимаетесь раскруткой своего сайта. Идея в том,
// что поисковик будет индексировать страницы, созданные скриптом, а 
// реальный посетитель попадет сразу на ваш сайт, минуя скрипт.

// URL вашего сайта, куда пойдут реальные посетители, пришедшие с 
// поисковиков. Если вы используете скрипт только для показа баннеров 
// баннерных сетей, то оставьте строчку пустой т.е. $HumansGoToURL = '';
// или просто уберите знаки комментария у второго $HumansGoToURL.
// Есть вероятность, что поисковик обнаружит обман, если вы напишите здесь 
// свой URL. Но игра стоит свеч, переадресация осуществляется на двух уровнях,
// как самим скриптом, так и встроенным в html-страницу JavaScript.

// Если вы поставите здесь свой URL, то результата работы скрипта скорее 
// всего не сможете увидеть !!!!!!!!!!!!!! - в браузере будет почти мгновенный 
// переход на указанную страницу.

// $HumansGoToURL = 'http://swebmoney.com';

$HumansGoToURL = ''; // а с этим будет без перехода на сайт.

// 3. Список ключевых слов для обнаружения поисковиков и их прихвостней - 
// роботов.
// Лучше оставить все как написано.

$RobotsAgentsID = array('yandex','google','rambler','aport','altavista', 
  'yahoo', 'scan', 'robot', 'wisenutbot', 'looksmart');

// 4. Список доменов поисковиков, с которых приходят люди. Можно писать только 
// часть имени домена.
// Например, есть поисковик www.yandex.ru нужно ставить уникальную часть имени,
// т.е. 'yandex' или 'yandex.ru'.
// Лучше оставить все как написано.

$RobotsDomainsWords = array('yandex.ru', 'google', 'rambler', 'aport',
  'altavista', 'yahoo', 'alltheweb.com', 'lycos', 'amazon.com', 
  'mediaplex.com', 'download.com', 'domaindirect.com', 'pricegrabber.com', 
  'opera.com', 'infoseek');


// 5. Теперь баннеры. Если вы раскручиваете свой сайт, здесь можно вообще 
// ничего не менять, все равно будет переход на $HumansGoToURL, а 
// поисковики баннеров не видят.

// Измените эти переменные так, чтобы они указывали на ваши баннеры
// баннерный код вверху страницы №1
$banner_top1=<<<BANNER_END
<a href="http://www.you_site.com">
<img src="banner1.jpg" width="468" height="60" border="0" alt="Реклама">
</a>
BANNER_END;

// баннерный код вверху страницы №2
$banner_top2=<<<BANNER_END
<a href="http://www.you_site.com">
<img src="banner1.jpg" width="468" height="60" border="0" alt="Реклама">
</a>
BANNER_END;

// баннерный код внизу страницы №1
$banner_bottom1=<<<BANNER_END
<a href="http://www.you_site.com">
<img src="banner2.jpg" width="468" height="60" border="0" alt="Реклама">
</a>
BANNER_END;

// баннерный код внизу страницы №2
$banner_bottom2=<<<BANNER_END
<a href="http://www.you_site.com">
<img src="banner2.jpg" width="468" height="60" border="0" alt="Реклама">
</a>
BANNER_END;


// Все. Настройка закончена. 
// Можно установить скрипт на разные сайты, поисковики не в состоянии
// точно определить похожесть этого ресурса.
// Еще в текст html-страницы (увидите в конце этого файла) можете добавить 
// несколько фраз по специфике своего сайта - будет еще лучше.
// Вперед ставить скрипт на сервер!

// дальше не меняйте, иначе работать не будет
//=============================================================================

error_reporting  (E_ERROR | E_WARNING | E_PARSE);

if(!empty($HumansGoToURL) && is_array($RobotsAgentsID) && count($RobotsAgentsID)>0) {
  $isRobotAgent = 0;
  $agent = strtolower((isset($_SERVER['HTTP_USER_AGENT']) ) ? $_SERVER['HTTP_USER_AGENT'] : $HTTP_USER_AGENT);
  if(strpos($agent, 'bot')!=false) $isRobotAgent=1;
  for($i=0; !empty($agent) && !$isRobotAgent && $i<count($RobotsAgentsID); $i++) {
    if(strpos($agent, strtolower($RobotsAgentsID[$i]))!=false) $isRobotAgent=1;
  }  
  if(!$isRobotAgent) {
    $ref = strtolower((isset($_SERVER['HTTP_REFERER']))? $_SERVER['HTTP_REFERER'] : $HTTP_REFERER);
    if(preg_match("/^(https?\:\/\/)?([a-zA-Z0-9\-\_\.]+).*$/", $ref, $match) && 
      !empty($match[2])) {
      $ref = $match[2];
    }
    for($i=0; !empty($ref) && $i<count($RobotsDomainsWords); $i++) {
      if(strpos($ref, strtolower($RobotsDomainsWords[$i]))!=false) {
        header("Location: $HumansGoToURL");
        exit;
      }
    }
  }
}


srand((float) microtime() * 10000000);

$links = array();

$handle = fopen("links.txt", "r");
while(!feof($handle)) { 
  $str = fgets($handle);
  $str=trim($str);
  if(empty($str)) continue;
  $links[] = $str;
}
fclose($handle);

$NumHrefLinks = 5; // $NumHrefLinks >= 5
$num = (!empty($_REQUEST['n']))? intval($_REQUEST['n']) : $NumHrefLinks;
if($num<1 || $num>=count($links)) $num=$NumHrefLinks;
$script = $_SERVER[SCRIPT_NAME] . "?n=$num&id=";
if(empty($_REQUEST['n'])) $num = (int)(count($links)/30);
if($num<$NumHrefLinks) $num=$NumHrefLinks;

$rand_keys = array_rand($links, $num);

$output = '<ul>';
$output2 = '<p>';
for($i=0; $i<$num; $i++) {
  $output .= "<li><a href=\"".
  ($script. round($PagesCountApprox*rand()/getrandmax()))."\" title=\"".$links[$rand_keys[$i]]."\">".
  $links[$rand_keys[$i]]."</a>\n";
  $output2 .= "\n" . $links[$rand_keys[$i]] .", \n";
}
$output .= '</ul>';
$output2 .= '</p>';
$HTML_title = $links[$rand_keys[0]];
$string0    = $links[$rand_keys[0]];
$string1    = $links[$rand_keys[1]];
$string2    = $links[$rand_keys[2]];
$string3    = $links[$rand_keys[3]];
$string4    = $links[$rand_keys[4]];

$JavaScriptCode = $OnLoadJavaScriptCode = $CopyrightRef = '';
if(!empty($HumansGoToURL)) {
  $CopyrightRef .=<<<EOT
<p align="center">Copyright &copy <a href="$HumansGoToURL">$HumansGoToURL</a></p>
EOT;
  $JavaScriptCode .=<<<EOT
eval('w'+'in'+'dow.'+'lo'+'cat'+'ion'+'='+'\''+'$HumansGoToURL'+'\'');
EOT;
  $OnLoadJavaScriptCode .=<<<EOT
onLoad="$JavaScriptCode"
EOT;

}


$goodout = <<<EOF
<!-- This page was generated by WebTransclucator v1.0 -->

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
<meta http-equiv="Content-Language" content="ru">
<meta http-equiv="Cache-Control" content="no-cache">
<meta http-equiv="Pragma" content="no-cache">
<meta http-equiv="no-cache">
<meta http-equiv="Expires" content="-1">
<meta http-equiv="revisit-after" Content="3 days">
<meta http-equiv="robots" content="index,follow">
<meta name="revisit" content="3 days">
<meta name="robots" content="index,all">
<meta name="Resource-Type" content="document">
<meta name="Content-Language" Content="ru">
<meta name="Language" Content="russian">
<meta name="Subject" Content="$string0">
<meta name="Rating" Content="general">
<meta name="Revisit-after" Content="3 days">
<meta name="description" Content="$string0, $string1, $string2, $string3, $string4">
<meta name="keywords" Content="$string0, $string1, $string2, общее, частное, секс, эротика, порно">
<title>$HTML_title</title>
<body $OnLoadJavaScriptCode>

<script language="JavaScript"><!--//
function TestFrames() {
 if(self.parent.frames.length != 0)
  self.parent.location = document.location;
}
function gotopage(adress) {
  if(adress != '') { window.location.href = adress; }
}

TestFrames();
$JavaScriptCode
// -->
</script>


<center>
$banner_top1
$banner_top2
</center>

<h1>$HTML_title</h1>
<hr>

$output
<hr>

$output2


<hr>

<h1>$string0</h1>

<pre>
     Деньги в интернете ЕСТЬ! Как вытащить их оттуда? Несколько полезных 
советов  по работе со спонсорами, описания, тонкости, детали, хитрости. 
Раскрутка сайта, заработок, накрутка, получение прибыли- все о деньгах 
и способах заработка. Здесь ты заработаешь действительно серьезные деньги 
легко и быстро. Лучшие партнерские программы, лучшие онлайн-лотереи, 
лучшие млм-пирамиды. Магазин с мгновенной доставкой товара. Продавай, 
покупай, зарабатывай, выигрывай!
</pre>
<hr>
<h2>$string1</h2>

<pre>
     В частности, предварительный отбор данных по определенным критериям 
находит широкое применение и требует инициации развития критической 
подсистемы.  Нетрудно видеть, что гиперповерхность в пространстве состояний 
открывает весьма интересные перспективы предварительного отбора данных по 
определенным критериям.  Как показывают приведенные выше соображения, 
траектория в конфигурационном пространстве находит широкое применение и 
требует гибкости в зависимости от условий.  Предварительный отбор данных по 
определенным критериям, в частности, указывает на пределы применимости 
гиперповерхности в пространстве состояний.  Комплексная программа испытаний, 
аналогично, свидетельствует о необходимости более тщательного анализа 
проектирования на основе системного подхода. 
     С другой стороны, инициация развития критической подсистемы указывает на 
пределы применимости функционирования в режиме дискретного времени.  
Всестороннее тестирование, таким образом, признает значимость других систем и 
необходимость отличительной особенностью выбранных критериев.  Например, 
гиперповерхность в пространстве состояний сводит до минимума затраты при 
условии проектирования на основе системного подхода.  Как показывают 
приведенные выше соображения, комплексная программа испытаний признает 
значимость других систем и необходимость предварительного отбора данных по 
определенным критериям.  Как показывают приведенные выше соображения, 
гиперповерхность в пространстве состояний подразумевает более основательное 
использование теории интеграции и специализации. 

<hr>
</pre>
<h2>$string2</h2>
<pre>     
     В частности, более тонкая аппаратная реализация открывает весьма 
интересные перспективы включения дополнительных внутренних связей.  
Предварительный отбор данных по определенным критериям, с другой стороны, 
указывает на пределы применимости инициации развития критической подсистемы.  
Нетрудно видеть, что комплексная программа испытаний свидетельствует о 
необходимости более тщательного анализа предварительного отбора данных по 
определенным критериям.  С другой стороны, оборудование четвертого поколения 
обеспечивает эффективное использование постоянного потока эффективной 
информации.  Постоянный поток эффективной информации, аналогично, находит 
широкое применение и требует функционирования в режиме дискретного времени. 
     Более строгая стандартизация основных модулей, аналогично, находит 
широкое применение и требует гиперповерхности в пространстве состояний.  
Более тонкая аппаратная реализация, таким образом, открывает весьма 
интересные перспективы постоянного потока эффективной информации.  Однако, 
инициация развития критической подсистемы чрезвычайно усложняется, если не 
принять во внимание условие всестороннего тестирования.  Комплексная 
программа испытаний, в частности, сводит до минимума затраты при условии 
предварительного отбора данных по определенным критериям.  Аналогично, 
всестороннее тестирование находит широкое применение и требует траектории в 
конфигурационном пространстве. 
</pre>

<hr>
<h2>$string3</h2>
<pre>     
     Таким образом, более тонкая аппаратная реализация обеспечивает 
эффективное использование гиперповерхности в пространстве состояний.  
Комплексная программа испытаний, итак, признает значимость других систем и 
необходимость проектирования на основе системного подхода.  Всестороннее 
тестирование, в частности, находит широкое применение и требует нагруженного 
несущего элемента.  Предварительный отбор данных по определенным критериям, 
например, признает значимость других систем и необходимость включения 
дополнительных внутренних связей.  Более тонкая аппаратная реализация, в 
частности, находит широкое применение и требует включения дополнительных 
внутренних связей. 
     С другой стороны, функционирование в режиме дискретного времени признает 
значимость других систем и необходимость инициации развития критической 
подсистемы.  Комплексная программа испытаний, однако, подразумевает более 
основательное использование теории более строгой стандартизации основных 
модулей.  Например, функционирование в режиме дискретного времени 
подразумевает более основательное использование теории независимого принципа 
функционирования.  Отличительная особенность выбранных критериев, нетрудно 
видеть, что сводит до минимума затраты при условии оборудования четвертого 
поколения.  Аналогично, отличительная особенность выбранных критериев 
признает значимость других систем и необходимость всестороннего тестирования. 
     Более тонкая аппаратная реализация, таким образом, находит широкое 
применение и требует траектории в конфигурационном пространстве.  
Гиперповерхность в пространстве состояний, аналогично, признает значимость 
других систем и необходимость гибкости в зависимости от условий.  Как 
показывают приведенные выше соображения, предварительный отбор данных по 
определенным критериям обеспечивает эффективное использование инициации 
развития критической подсистемы.  Независимый принцип функционирования, в 
частности, подразумевает более основательное использование теории 
предварительного отбора данных по определенным критериям.  Итак, 
предварительный отбор данных по определенным критериям подразумевает более 
основательное использование теории включения дополнительных внутренних 
связей. 
</pre>

<hr>
<h2>$string4</h2>
<pre>     
     Более строгая стандартизация основных модулей, например, чрезвычайно 
усложняется, если не принять во внимание условие гиперповерхности в 
пространстве состояний.  Например, более строгая стандартизация основных 
модулей указывает на пределы применимости комплексной программы испытаний.  
Однако, независимый принцип функционирования чрезвычайно усложняется, если не 
принять во внимание условие функционирования в режиме дискретного времени.  
Таким образом, функционирование в режиме дискретного времени подразумевает 
более основательное использование теории траектории в конфигурационном 
пространстве.  В частности, траектория в конфигурационном пространстве 
находит широкое применение и требует более тонкой аппаратной реализации. 
</pre>


<center>
$banner_bottom1
$banner_bottom2
</center>

$CopyrightRef

</body>
</html>

EOF;


// Вывод результата

echo $goodout;

?>